package com.openhis.web.materialmanage.appservice.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.core.common.core.domain.R;
import com.core.common.utils.AssignSeqUtil;
import com.core.common.utils.DateUtils;
import com.core.common.utils.MessageUtils;
import com.openhis.common.constant.CommonConstants;
import com.openhis.common.constant.PromptMsgConstant;
import com.openhis.common.enums.*;
import com.openhis.common.utils.EnumUtils;
import com.openhis.web.inventorymanage.dto.ProductStocktakingInitDto;
import com.openhis.web.materialmanage.appservice.IMaterialCommonService;
import com.openhis.web.materialmanage.appservice.IMaterialTransferOutOrderService;
import com.openhis.web.materialmanage.dto.MaterialDetailDto;
import com.openhis.web.materialmanage.dto.MaterialInitDto;
import com.openhis.web.materialmanage.mapper.MaterialCommonMapper;
import com.openhis.web.materialmanage.mapper.MaterialTransferOutOrderMapper;
import com.openhis.workflow.domain.SupplyRequest;
import com.openhis.workflow.service.ISupplyRequestService;

/**
 * 物资调出单
 *
 * @author yuxj
 * @date 2025-07-22
 */
@Service
public class MaterialTransferOutOrderServiceImpl implements IMaterialTransferOutOrderService {

    @Resource
    private AssignSeqUtil assignSeqUtil;
    @Resource
    private ISupplyRequestService supplyRequestService;
    @Autowired
    private IMaterialCommonService materialCommonService;
    @Autowired
    private MaterialCommonMapper materialCommonMapper;

    /**
     * 初始化
     *
     * @return 初始化信息
     */
    @Override
    public R<?> init() {

        MaterialInitDto purchaseOrderInitDto = materialCommonService.init();

        // 单据分类
        List<MaterialInitDto.IntegerOption> supplyCategoryOption = new ArrayList<>();
//        supplyCategoryOption.add(new MaterialInitDto.IntegerOption(SupplyCategory.NORMAL.getValue(),
//            SupplyCategory.NORMAL.getInfo()));

        purchaseOrderInitDto.setSupplyCategoryOptions(supplyCategoryOption);

        return R.ok(purchaseOrderInitDto);
    }

    /**
     * 调出单单据详情
     *
     * @param busNo 单据号
     * @param pageNo 当前页码
     * @param pageSize 查询条数
     * @return 调出单单据详情
     */
    @Override
    public R<?> getDetailPage(String busNo, Integer pageNo, Integer pageSize) {

        Page<MaterialDetailDto> transferOutOrderDtoDetailPage =
            materialCommonMapper.getDetailPage(new Page<>(pageNo, pageSize), busNo);

        transferOutOrderDtoDetailPage.getRecords().forEach(e -> {
            // 单据分类
            e.setCategoryEnum_enumText(EnumUtils.getInfoByValue(SupplyCategory.class, e.getCategoryEnum()));
            // 单据状态
            e.setStatusEnum_enumText(EnumUtils.getInfoByValue(SupplyStatus.class, e.getStatusEnum()));
            // 单据类型
            e.setTypeEnum_enumText(EnumUtils.getInfoByValue(SupplyType.class, e.getTypeEnum()));
        });

        List<MaterialDetailDto.Option> unitList;
        for (MaterialDetailDto item : transferOutOrderDtoDetailPage.getRecords()) {
            unitList = new ArrayList<>();
            unitList.add(new MaterialDetailDto.Option(item.getMaxUnitCode(), item.getMaxUnitCode_dictText()));
            unitList.add(new MaterialDetailDto.Option(item.getMinUnitCode(), item.getMinUnitCode_dictText()));

            item.setUnitList(unitList);
        }

        return R.ok(transferOutOrderDtoDetailPage);
    }

    /**
     * 获取单据号
     *
     * @return 初始化信息
     */
    @Override
    public R<?> getBusNo() {

        ProductStocktakingInitDto initDto = new ProductStocktakingInitDto();
        // 单据号
        initDto.setBusNo(assignSeqUtil.getSeqByDay(AssignSeqEnum.MATERIAL_TRANSFEROUT.getPrefix(), 4));

        return R.ok(initDto);
    }

    /**
     * 添加/编辑调入单
     *
     * @param transferOutOrderDtoList 调入信息
     * @return 操作结果
     */

    @Override
    public R<?> addOrEditTransferOutOrder(List<MaterialDetailDto> transferOutOrderDtoList) {
        // 请求数据取得
        List<SupplyRequest> requestList = supplyRequestService.getSupplyByBusNo(transferOutOrderDtoList.get(0).getBusNo());
        if (!requestList.isEmpty()) {
            // 请求id取得
            List<Long> requestIdList = requestList.stream().map(SupplyRequest::getId).collect(Collectors.toList());
            // 单据信息删除
            supplyRequestService.removeByIds(requestIdList);
        }

        List<SupplyRequest> supplyRequestList = new ArrayList<>();
        Date applyTime = DateUtils.getNowDate();
        for (MaterialDetailDto item : transferOutOrderDtoList) {
            SupplyRequest supplyRequest = new SupplyRequest().setBusNo(item.getBusNo())
                .setTypeEnum(SupplyType.MATERIAL_TRANSFEROUT.getValue())
                .setStatusEnum(SupplyStatus.PENDING_REVIEW.getValue())
                .setItemTable(CommonConstants.TableName.ADM_DEVICE_DEFINITION).setItemId(item.getItemId())
                .setUnitCode(item.getUnitCode()).setItemQuantity(item.getItemQuantity()).setRetailPrice(item.getPrice())
                .setTotalRetailPrice(item.getTotalPrice()).setBatchInventory(item.getBatchInventory())
                .setSpecificationInventory(item.getSpecificationInventory()).setEndTime(item.getEndTime())
                .setLotNumber(item.getLotNumber()).setTraceNo(item.getTraceNo())
                .setTraceNoUnitCode(item.getTraceNoUnitCode()).setSupplierId(item.getSupplierId())
                .setReason(item.getReason()).setSourceTypeEnum(LocationForm.WAREHOUSE.getValue())
                .setSourceLocationId(item.getSourceLocationId()).setPurposeTypeEnum(LocationForm.WAREHOUSE.getValue())
                .setPurposeLocationId(item.getPurposeLocationId())
                .setApplicantId(item.getApplicantId()).setApplyTime(applyTime).setRemake(item.getRemake());
            supplyRequestList.add(supplyRequest);
        }
        // 更新请求表
        boolean flg = supplyRequestService.saveOrUpdateBatch(supplyRequestList);
        if (!flg) {
            return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00011, null));
        }

        return R.ok(MessageUtils.createMessage(PromptMsgConstant.Common.M00004, null));
    }

}
